<template>
  <div></div>
</template>

<script>
// Vendor
import { marker, divIcon } from 'leaflet'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

// Store
import { SET_QUERY, mutationNameResolve } from '@/store/workspace/mutations'

// Utilities
import { findParentComponentByName } from '@/core/util'
import '@/core/leaflet'

export default {
  name: 'leafletmarker',
  
  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    identifier: {
      type: String,
      required: true,
    },
  },

  computed: {
    leafletMap: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletmap')
      }
    },

    leafletPane: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletpane')
      }
    },

    locationDefinition: {
      get() {
        return this.$store.getters.getLocationById(this.identifier)
      },
    },

    // Current status of this layer in the workspace context state
    locationStatus: {
      get() {
        return this.$store.state[this.workspace].locations.find(location => location.id === this.identifier).active
      },
    },
  },

  watch: {
    // Watcher method for the layer status. Adds or removes the layer from the parent
    // map object depending on the current status in this workspace.
    locationStatus(after) {
      if(after) {
        this.add()
      } else {
        this.remove()
      }
    },
  },

  methods: {
    create() {
      this.layerObject = marker([
        this.locationDefinition.latitude,
        this.locationDefinition.longitude
      ], {
        icon: this.getIcon()
      }).on('click', () => { this.updateQuery() })
      return this
    },

    add() {
      this.layerObject.addTo(this.leafletMap.mapObject)
    },

    remove() {
      this.layerObject.remove()
    },

    updateQuery() {
      this.$store.commit(mutationNameResolve(this.workspace, SET_QUERY), { query: {
        id: this.identifier,
      }})
    },

    getIcon() {
      return divIcon({
        className: 'custom-div-icon',
        html: '<div class="internal-custom-icon"></div>',
      })
    },
  },

  mounted() {
    this.create()
  },
}
</script>

<style>
div.leaflet-marker-icon.custom-div-icon {
  width: 20px !important;
  height: 20px !important;
  background-color: none;
  box-shadow: 2px 2px rgba(0.3, 0.3, 0.8, 0.6);
  border-radius: 10px;
  border: 2px solid #007bff;
  position: relative;
  left: -10px;
  top: -10px;
}
div.leaflet-marker-icon.custom-div-icon:hover {
  width: 24px !important;
  height: 24px !important;
  border-radius: 12px;
  border: 3px solid #007bff;
  left: -12px;
  top: -12px;
}

div.leaflet-marker-icon.custom-div-icon div.internal-custom-icon {
  width: 12px !important;
  height: 12px !important;
  background-color: #007bff !important;
  border-radius: 6px;
  position: relative;
  left: 2px;
  top: 2px;
}
div.leaflet-marker-icon.custom-div-icon:hover div.internal-custom-icon {
  width: 14px !important;
  height: 14px !important;
  left: 2px;
  top: 2px;
}
</style>
